type CallBack = (...args: any[]) => any;
/**
 * 网格索引，相比 @mapbox/grid-index，在简单计算碰撞检测结果时效率更高
 * @see https://zhuanlan.zhihu.com/p/74373214
 */
declare class GridIndex {
    private boxCells;
    private xCellCount;
    private yCellCount;
    private boxKeys;
    private bboxes;
    private width;
    private height;
    private xScale;
    private yScale;
    private boxUid;
    constructor(width: number, height: number, cellSize: number);
    insert(key: any, x1: number, y1: number, x2: number, y2: number): void;
    query(x1: number, y1: number, x2: number, y2: number, predicate?: CallBack): boolean | any[];
    hitTest(x1: number, y1: number, x2: number, y2: number, predicate?: CallBack): boolean | any[];
    private insertBoxCell;
    private queryHitTest;
    private queryCell;
    private forEachCell;
    private convertToXCellCoord;
    private convertToYCellCoord;
}
export default GridIndex;
